#include "../stdafx.h"
#include <stdlib.h>
#include "../cphidget.h"
#include "phidget_jni.h"
#include "com_phidgets_usb_Manager.h"
#include "com_phidgets_usb_Phidget.h"

jclass usb_phidget_class;

jmethodID com_phidgets_usb_Phidget_getSerialNumber_mid;
jmethodID com_phidgets_usb_Phidget_getUniqueName_mid;
jmethodID com_phidgets_usb_Phidget_getvID_mid;
jmethodID com_phidgets_usb_Phidget_getpID_mid;
jmethodID com_phidgets_usb_Phidget_getVersion_mid;
jmethodID com_phidgets_usb_Phidget_getInterfaceNum_mid;
jmethodID com_phidgets_usb_Phidget_getInputReportSize_mid;
jmethodID com_phidgets_usb_Phidget_getOutputReportSize_mid;
jmethodID com_phidgets_usb_Phidget_getLabel_mid;
jmethodID com_phidgets_usb_Phidget_close_mid;
jmethodID com_phidgets_usb_Phidget_write_mid;
jmethodID com_phidgets_usb_Phidget_setLabel_mid;
jmethodID com_phidgets_usb_Phidget_read_mid;

int
com_phidgets_usb_Phidget_OnLoad(JNIEnv *env)
{
	//USB Phidget
	if (!(usb_phidget_class = (*env)->FindClass(env, "com/phidgets/usb/Phidget")))
	{
		LOG(PHIDGET_LOG_INFO, "Running on Android without USB (Couldn't load com/phidgets/usb/Phidget).");
		(*env)->ExceptionClear(env);
		return PFALSE;
	}
	if (!(usb_phidget_class = (jclass)(*env)->NewGlobalRef(env, usb_phidget_class)))
		JNI_ABORT_STDERR("Couldn't get NewGlobalRef from usb_phidget_class");
	
	//Methods
	if (!(com_phidgets_usb_Phidget_getSerialNumber_mid = (*env)->GetMethodID(env, usb_phidget_class, "getSerialNumber", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getSerialNumber from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getUniqueName_mid = (*env)->GetMethodID(env, usb_phidget_class, "getUniqueName", "()Ljava/lang/String;")))
		JNI_ABORT_STDERR("Couldn't get method ID getUniqueName from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getvID_mid = (*env)->GetMethodID(env, usb_phidget_class, "getvID", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getvID from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getpID_mid = (*env)->GetMethodID(env, usb_phidget_class, "getpID", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getpID from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getVersion_mid = (*env)->GetMethodID(env, usb_phidget_class, "getVersion", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getVersion from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getInterfaceNum_mid = (*env)->GetMethodID(env, usb_phidget_class, "getInterfaceNum", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getInterfaceNum from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getInputReportSize_mid = (*env)->GetMethodID(env, usb_phidget_class, "getInputReportSize", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getInputReportSize from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getOutputReportSize_mid = (*env)->GetMethodID(env, usb_phidget_class, "getOutputReportSize", "()I")))
		JNI_ABORT_STDERR("Couldn't get method ID getOutputReportSize from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_getLabel_mid = (*env)->GetMethodID(env, usb_phidget_class, "getLabel", "()[B")))
		JNI_ABORT_STDERR("Couldn't get method ID getLabel from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_close_mid = (*env)->GetMethodID(env, usb_phidget_class, "close", "()V")))
		JNI_ABORT_STDERR("Couldn't get method ID close from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_write_mid = (*env)->GetMethodID(env, usb_phidget_class, "write", "([B)I")))
		JNI_ABORT_STDERR("Couldn't get method ID write from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_setLabel_mid = (*env)->GetMethodID(env, usb_phidget_class, "setLabel", "([B)I")))
		JNI_ABORT_STDERR("Couldn't get method ID setLabel from usb_phidget_class");
	
	if (!(com_phidgets_usb_Phidget_read_mid = (*env)->GetMethodID(env, usb_phidget_class, "read", "()[B")))
		JNI_ABORT_STDERR("Couldn't get method ID read from usb_phidget_class");
	
	return PTRUE;
}

int CPhidgetAndroid_closePhidget(CPhidgetHandle phid)
{
	JNIEnv *env;
	jint result;
	jobject jphid;
	int res = EPHIDGET_OK;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;
	
	if ((*ph_vm)->AttachCurrentThread(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThread");
	
	if(phid->deviceHandle)
	{
		LOG(PHIDGET_LOG_INFO, "CPhidgetAndroid_closePhidget -> closing the Phidget");
		(*env)->CallVoidMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_close_mid);
		(*env)->DeleteGlobalRef(env, (jobject)(uintptr_t)phid->deviceHandle);
		phid->deviceHandle = NULL;
	}
	
done:
	
	LOG(PHIDGET_LOG_INFO, "CPhidgetAndroid_closePhidget -> done closing.");
	return res;
}

int CPhidgetAndroid_openPhidget(CPhidgetHandle phid)
{
	JNIEnv *env;
	jint result;
	jobject jphid;
	jstring str;
	int res = EPHIDGET_OK;
	int serNum;
	char label[MAX_LABEL_STORAGE];
	jbyteArray labelArray;
	jbyte *datab;
	jsize len;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;
	
	if ((*ph_vm)->AttachCurrentThread(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThread");
	
	//Ready to call, etc.
	str = (*env)->NewStringUTF(env, (char *)phid->CPhidgetFHandle);
	if(str)
	{
		//First delete any old global ref
		if(phid->deviceHandle)
		{
			(*env)->CallVoidMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_close_mid);
			(*env)->DeleteGlobalRef(env, (jobject)(uintptr_t)phid->deviceHandle);
			phid->deviceHandle = NULL;
		}
		
		LOG(PHIDGET_LOG_INFO, "CPhidgetAndroid_openPhidget -> Opening: %s Interface: %d",(char *)phid->CPhidgetFHandle,phid->deviceDef->pdd_iid);
		jphid = (*env)->CallStaticObjectMethod(env, usb_manager_class, usb_manager_openPhidget, str, phid->deviceDef->pdd_iid);
		if(jphid)
		{
			serNum = phid->serialNumber = (*env)->CallIntMethod(env, jphid, com_phidgets_usb_Phidget_getSerialNumber_mid);
			
			if (phid->specificDevice == PHIDGETOPEN_SERIAL)
				if (phid->serialNumber != serNum)
				{
					res = EPHIDGET_NOTFOUND;
					goto done_str;
				}
			
			phid->serialNumber = serNum;
			
			labelArray = (*env)->CallObjectMethod(env, jphid, com_phidgets_usb_Phidget_getLabel_mid);
			if(labelArray)
			{
				len = (*env)->GetArrayLength(env, labelArray);
				datab = (*env)->GetByteArrayElements(env, labelArray, 0);
				if(datab)
				{
					if((res = decodeLabelString((char *)datab, label, phid->serialNumber)) != EPHIDGET_OK)
						ZEROMEM(label, MAX_LABEL_STORAGE);
					
					(*env)->ReleaseByteArrayElements(env, labelArray, datab, 0);
				}
				else
					ZEROMEM(label, MAX_LABEL_STORAGE);
				
				(*env)->DeleteLocalRef(env, labelArray);
			}
			else
				ZEROMEM(label, MAX_LABEL_STORAGE);
			
			if (phid->specificDevice == PHIDGETOPEN_LABEL)
				if (strncmp(phid->label, label, MAX_LABEL_STORAGE-1))
				{
					res = EPHIDGET_NOTFOUND;
					goto done_str;
				}
			
			memcpy(phid->label, label, MAX_LABEL_STORAGE);
			
			if ((jphid = (jobject)(*env)->NewGlobalRef(env, jphid)))
			{
				LOG(PHIDGET_LOG_INFO, "CPhidgetAndroid_openPhidget -> Got a successful opened device!");
				phid->deviceHandle = (uintptr_t *)jphid;
				
				//fill in remaining data
				
				phid->deviceType = Phid_DeviceName[phid->deviceID];
				phid->attr = phid->deviceDef->pdd_attr;
				
				phid->ProductID = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getpID_mid);
				phid->VendorID = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getvID_mid);
				phid->deviceVersion = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getVersion_mid);
				phid->deviceUID = CPhidget_getUID(phid->deviceIDSpec, phid->deviceVersion);
				
				phid->inputReportByteLength = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getInputReportSize_mid);
				phid->outputReportByteLength = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getOutputReportSize_mid);
				
				res = EPHIDGET_OK;
			}
			else
			{
				(*env)->DeleteLocalRef(env, jphid);
				LOG(PHIDGET_LOG_ERROR, "CPhidgetAndroid_openPhidget -> Unable to create global ref of phidget");
				res = EPHIDGET_UNEXPECTED;
			}
		}
		else
		{
			LOG(PHIDGET_LOG_ERROR, "CPhidgetAndroid_openPhidget -> usb_manager_openPhidget returned null!");
			res = EPHIDGET_UNEXPECTED;
		}
	done_str:
		(*env)->DeleteLocalRef(env, str);
	} //if(str)
	else
	{
		LOG(PHIDGET_LOG_ERROR, "CPhidgetAndroid_openPhidget -> NewStringUTF returned null!");
		res = EPHIDGET_UNEXPECTED;
	}
	
	return res;
}

int CPhidgetAndroid_write(CPhidgetHandle phid, unsigned char *buffer)
{
	JNIEnv *env;
	int res = EPHIDGET_OK;
	jbyte *datab;
	jbyteArray jb;
	int i, bytesSent;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;
 
	if ((*ph_vm)->AttachCurrentThread(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThread");

	jb = (*env)->NewByteArray(env, phid->outputReportByteLength);
	if(jb)
	{
		datab = (*env)->GetByteArrayElements(env, jb, 0);
		if(datab)
		{
			for (i=0; i<phid->outputReportByteLength; i++)
				datab[i] = (jbyte)buffer[i];
			(*env)->ReleaseByteArrayElements(env, jb, datab, 0);
			
			bytesSent = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_write_mid, jb);
			if(bytesSent < 0)
				res = EPHIDGET_UNEXPECTED;
		}
		else
		{
			res = EPHIDGET_UNEXPECTED;
		}
		
		(*env)->DeleteLocalRef(env, jb);
	}
	else
		res = EPHIDGET_UNEXPECTED;
	
	return res;
}

int CPhidgetAndroid_refreshLabel(CPhidgetHandle phid)
{
	JNIEnv *env;
	int res = EPHIDGET_OK;
	jbyte *datab;
	jbyteArray labelArray;
	jsize len;
	jint result;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;
	
	result = (*ph_vm)->GetEnv(ph_vm, (void **)&env, JNI_VERSION_1_4);
	
	if(result >= 0)
	{
		LOG(PHIDGET_LOG_INFO, "Refreshing label in CPhidgetAndroid_refreshLabel...");
		labelArray = (*env)->CallObjectMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_getLabel_mid);
		if(labelArray)
		{
			len = (*env)->GetArrayLength(env, labelArray);
			
			datab = (*env)->GetByteArrayElements(env, labelArray, 0);
			if(datab)
			{
				if((res = decodeLabelString((char *)datab, phid->label, phid->serialNumber)) != EPHIDGET_OK)
					phid->label[0]='\0';
				
				(*env)->ReleaseByteArrayElements(env, labelArray, datab, 0);
			}
			else
				phid->label[0]='\0';
			
			(*env)->DeleteLocalRef(env, labelArray);
			LOG(PHIDGET_LOG_INFO, "Done refreshing label in CPhidgetAndroid_refreshLabel: %s", phid->label);
		}
		else
		{
			res = EPHIDGET_UNEXPECTED;
		}
	}
	else
	{
		LOG(PHIDGET_LOG_ERROR, "Couldn't get env in CPhidgetAndroid_refreshLabel: %d", result);
		res = EPHIDGET_UNEXPECTED;
	}
	
	return res;

}

int CPhidgetAndroid_setLabel(CPhidgetHandle phid, char *buffer)
{
	JNIEnv *env;
	int res = EPHIDGET_OK;
	jbyte *datab;
	jbyteArray jb;
	int i, bytesSent;
	jint result;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;
	
	result = (*ph_vm)->GetEnv(ph_vm, (void **)&env, JNI_VERSION_1_4);
	
	if(result >= 0)
	{
		LOG(PHIDGET_LOG_INFO, "Setting label in CPhidgetAndroid_setLabel...");
		jb = (*env)->NewByteArray(env, buffer[0]);
		if(jb)
		{
			datab = (*env)->GetByteArrayElements(env, jb, 0);
			if(datab)
			{
				for (i=0; i<buffer[0]; i++)
					datab[i] = (jbyte)buffer[i];
				(*env)->ReleaseByteArrayElements(env, jb, datab, 0);
				
				bytesSent = (*env)->CallIntMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_setLabel_mid, jb);
				
				if(bytesSent < 0)
				{
					res = EPHIDGET_UNEXPECTED;
				}
				LOG(PHIDGET_LOG_INFO, "Done setting label in CPhidgetAndroid_setLabel.");
			}
			else
			{
				res = EPHIDGET_UNEXPECTED;
			}
			
			(*env)->DeleteLocalRef(env, jb);
		}
		else
			res = EPHIDGET_UNEXPECTED;
	}
	else
	{
		LOG(PHIDGET_LOG_ERROR, "Couldn't get env in CPhidgetAndroid_setLabel: %d", result);
		res = EPHIDGET_UNEXPECTED;
	}
	
	return res;
}

int CPhidgetAndroid_read(CPhidgetHandle phid, unsigned char *buffer)
{
	JNIEnv *env;
	int res = EPHIDGET_OK;
	jbyteArray readArray;
	jbyte *datab;
	jsize len;
	
	if(!ANDROID_USB_GOOD)
		return EPHIDGET_UNSUPPORTED;

	if ((*ph_vm)->AttachCurrentThread(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThread");
	
	//Read Data - this will probably block?
	readArray = (*env)->CallObjectMethod(env, phid->deviceHandle, com_phidgets_usb_Phidget_read_mid);
	if(readArray)
	{
		len = (*env)->GetArrayLength(env, readArray);
		
		datab = (*env)->GetByteArrayElements(env, readArray, 0);
		if(datab)
		{
			memcpy(buffer, datab, len);
			(*env)->ReleaseByteArrayElements(env, readArray, datab, 0);
		}
		else
		{
			res = EPHIDGET_UNEXPECTED;
		}
		
		(*env)->DeleteLocalRef(env, readArray);
	}
	else
	{
		res = EPHIDGET_UNEXPECTED;
	}
	
	return res;
}
